#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <dlfcn.h>
#include "CANMateDll.h"

#define TOTAL_USB	4

typedef int BOOL;
BOOL InitStatus;

/* gtk widget variables */
GtkWidget *window;
GtkWidget *opendev,*closedev,*send,*recv,*stoprecv;
GtkWidget *normal,*logw,*loop,*ID_label,*DLC_label,*popup,*popup_label,*popup_but,*combo,*Abt,*AbtClose;
GtkWidget *D0Lab,*D1Lab,*D2Lab,*D3Lab,*D4Lab,*D5Lab,*D6Lab,*D7Lab;
GtkWidget *D0En,*D1En,*D2En,*D3En,*D4En,*D5En,*D6En,*D7En;
GtkListStore *store;
GtkTreeIter iter;

typedef HANDLE __stdcall (*fnOpenCANMate)(LPVOID, LPVOID);
typedef int __stdcall (*fnCloseCANMate)(HANDLE);
typedef int __stdcall (*fnGetCurrentBaudRate)(HANDLE, int*);
typedef int __stdcall (*fnSetCANBaudRate)(HANDLE, char);
typedef int __stdcall (*fnGetCurrentMode)(HANDLE, int);
typedef int __stdcall (*fnSetNormalMode)(HANDLE);
typedef int __stdcall (*fnSetLoopbackMode)(HANDLE);
typedef int __stdcall (*fnStartReception)(HANDLE);
typedef int __stdcall (*fnStopReception)(HANDLE);
typedef int __stdcall (*fnWriteCANMessage)(HANDLE, CANMsg*);
typedef int __stdcall (*fnGetFirmwareVersion)(HANDLE, int*);
typedef double __stdcall (*fnGetCANTimeStamp)(unsigned char, unsigned char);

void *pLib_Handle = NULL;
struct
{
    fnOpenCANMate OpenCANMate;
    fnCloseCANMate CloseCANMate;
    fnGetCurrentBaudRate GetCurrentBaudRate;
    fnSetCANBaudRate SetCANBaudRate;
    fnGetCurrentMode GetCurrentMode;
    fnSetNormalMode SetNormalMode;
    fnSetLoopbackMode SetLoopbackMode;
    fnStartReception StartReception;
    fnStopReception StopReception;
    fnWriteCANMessage WriteCANMessage;
    fnGetFirmwareVersion GetFirmwareVersion;
    fnGetCANTimeStamp GetCANTimeStamp;
} CM_Operations;

BOOL InitLib()
{
    char *error;

    pLib_Handle = dlopen("/usr/lib/libCANMATE.so", RTLD_LAZY);
    if (!pLib_Handle)
    {
        gtk_label_set_text(GTK_LABEL(popup_label), "Failed to Load Library");
        gtk_widget_show(popup);
        g_signal_connect (popup, "response", G_CALLBACK (gtk_main_quit), NULL);
        return FALSE;
    }

    CM_Operations.OpenCANMate = dlsym(pLib_Handle, "OpenCANMate");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }

    CM_Operations.CloseCANMate = dlsym(pLib_Handle, "CloseCANMate");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }

    CM_Operations.GetCurrentBaudRate = dlsym(pLib_Handle, "GetCurrentBaudRate");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }

    CM_Operations.SetCANBaudRate = dlsym(pLib_Handle, "SetCANBaudRate");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }
    CM_Operations.GetCurrentMode = dlsym(pLib_Handle, "GetCurrentMode");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }
    CM_Operations.SetNormalMode = dlsym(pLib_Handle, "SetNormalMode");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }
    CM_Operations.SetLoopbackMode = dlsym(pLib_Handle, "SetLoopbackMode");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }
    CM_Operations.StartReception = dlsym(pLib_Handle, "StartReception");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }
    CM_Operations.StopReception = dlsym(pLib_Handle, "StopReception");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }
    CM_Operations.WriteCANMessage = dlsym(pLib_Handle, "WriteCANMessage");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }
    CM_Operations.GetFirmwareVersion = dlsym(pLib_Handle, "GetFirmwareVersion");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }
    CM_Operations.GetCANTimeStamp = dlsym(pLib_Handle, "GetCANTimeStamp");
    if ((error = dlerror()) != NULL)
    {
        g_print("DD %s\n", error);
        return FALSE;
    }

    return TRUE;
}

void DeInitLib()
{
    CM_Operations.OpenCANMate        = NULL;
    CM_Operations.CloseCANMate       = NULL;
    CM_Operations.SetCANBaudRate     = NULL;
    CM_Operations.GetCurrentMode     = NULL;
    CM_Operations.SetNormalMode      = NULL;
    CM_Operations.SetLoopbackMode    = NULL;
    CM_Operations.StartReception     = NULL;
    CM_Operations.StopReception      = NULL;
    CM_Operations.WriteCANMessage    = NULL;
    CM_Operations.GetCANTimeStamp    = NULL;
    CM_Operations.GetFirmwareVersion = NULL;
    CM_Operations.GetCurrentBaudRate = NULL;


    dlclose(pLib_Handle);
    pLib_Handle = NULL;
}

CANMsg gCANMsg; 	// structure for data
unsigned char *plBuf = (unsigned char *)&gCANMsg;

/******************************* VARIABLES *****************************************************/

gint DLC_N;
char str[]="#,TimeStamp,ID,DLC,D0,D1,D2,D3,D4,D5,D6,D7,Type \n" ;


int ItemNo;
char *Type;  //For Rx & Tx
unsigned char PrintValueRx[11][3];/* for printing  receive hex values in liststore as string */
unsigned char PrintValueTx[11][3];/* for printing  transmit hex values in liststore as string */
char LogPath[50]= {0}; //path for Log file

BOOL BaudSet = FALSE;
BOOL Recep = FALSE;

CANMsg LoopValue;

FILE *csv = NULL;

HANDLE CANMateDev = -1;

BOOL BOpenPORT = FALSE;
BOOL BLoop     = FALSE;
BOOL BBAUD     = FALSE;
BOOL BReadRX   = FALSE;
BOOL BTxCAN    = FALSE;
BOOL BStopRX   = FALSE;


/******************************* FUNCTIONS *****************************************************/

void show_loop();

void DebugPrint(char info[50])
{
    printf("%s",info);
}


void TxCAN(void)
{
    CM_Operations.WriteCANMessage(CANMateDev, &gCANMsg);
    BTxCAN = TRUE;
}


int ProcessEvent(CANEvent *ptrEvent)
{
    // perror("ProcessEvent\n");
    return 0;
}

int ProcessData(CANMsg *ptrMsg, int *ptrNumMsgs)
{
    LoopValue = *ptrMsg;
    Type = "Rx";
    //perror("ProcessData\n");
    show_loop();
    return 0;
}

/*function close canmate*/
/*closes file descripter of log file if it opened*/
/*disables baudrate,loopback,normal and log buttons*/
static void close_can (GtkWidget *widget,gpointer   data)
{
    BOpenPORT = FALSE;
    BaudSet = FALSE;
    if(csv != NULL)
    {
        fclose(csv);
        csv = NULL;
    }

    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(loop),0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(normal),0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(logw),0);
    //gtk_combo_box_text_set_active_text(combo,0);
    gtk_combo_box_set_active (combo,0);
    gtk_widget_set_sensitive(normal,BaudSet);
    gtk_widget_set_sensitive(loop,BaudSet);
    gtk_widget_set_sensitive(logw,BaudSet);
    CM_Operations.CloseCANMate(CANMateDev);//add
    gtk_widget_set_sensitive(closedev,BOpenPORT);
    gtk_widget_set_sensitive(send,BOpenPORT);
    gtk_widget_set_sensitive(recv,BOpenPORT);
    gtk_widget_set_sensitive(stoprecv,BOpenPORT);
}

/*
Function to set user and path of logfile to Desktop
*/
void FindPath()
{
    char bash_cmd[50] = "whoami";
    char buffer[50];
    FILE *pipes;
    int len;

    char str1[50]="/home/";
    char str2[50]="/Desktop/CANMate_log.csv";

    pipes = popen(bash_cmd, "r");
    fgets(buffer, sizeof(buffer), pipes);
    len = strlen(buffer);
    buffer[len-1] = '\0';
    pclose(pipes);

    strcat(buffer,str2);
    strcat(str1,buffer);
    strcat(LogPath,str1);
}

/*function creates a file descriptor for log file if not exist*/
/*file open for appending values if log buttton activated*/
/*close file descriptor if log button deactivated*/
static void log_file (GtkWidget *widget,gpointer   data)
{
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
    {
        if(csv == NULL)
        {
            csv = fopen(LogPath, "a+");

            if(csv > 0)
            {
                if(fgetc(csv) == EOF)
                {
                    fwrite(str , 1 , sizeof(str) , csv );
                }
            }
        }
        else
        {
            fclose(csv);
            csv = NULL;
        }
    }

}
/* function assign selected baudrate from combo selection box*/
/* selected baudrate assigned by comparing the string from combo */
/* activates loopback,normal and logw buttons for selection if right baudrate selected*/

void combo_selected(GtkWidget *widget, gpointer window)
{
    int RetCheck;
    static int pBaudList[] = { 0, BAUD_RATE33K, BAUD_RATE50K, BAUD_RATE80K, BAUD_RATE83K, BAUD_RATE100K, BAUD_RATE125K,
                               BAUD_RATE200K, BAUD_RATE250K, BAUD_RATE500K, BAUD_RATE625K, BAUD_RATE800K, BAUD_RATE1000K
                             };
    if(BOpenPORT)
    {
        //gchar *text = (char *) gtk_combo_box_text_get_active_text(GTK_COMBO_BOX_TEXT(widget));
        gint index = gtk_combo_box_get_active(GTK_COMBO_BOX_TEXT(widget));
        if(index > 0)
        {
            RetCheck = CM_Operations.SetCANBaudRate(CANMateDev, pBaudList[index]);
            if(CANMATE_ERROR_SUCCESS != RetCheck)
            {
                gtk_label_set_text(GTK_LABEL(popup_label), "Baud Selection Failed");
                gtk_widget_show(popup);
            }
            BaudSet = TRUE;
        }
        else
        {
            BaudSet = FALSE;
            gtk_label_set_text(GTK_LABEL(popup_label), "Wrong Baud Rate");
            gtk_widget_show(popup);
        }

        gtk_widget_set_sensitive(loop,BaudSet);
        gtk_widget_set_sensitive(normal,BaudSet);
        gtk_widget_set_sensitive(logw,BaudSet);
    }
    else
    {
        gint index = gtk_combo_box_get_active(GTK_COMBO_BOX_TEXT(widget));
        if(index > 0)
        {
            gtk_label_set_text(GTK_LABEL(popup_label), "Device not opened");
            gtk_widget_show(popup);
            gtk_combo_box_set_active (combo,0);
        }
    }
}

static void loop_back (GtkWidget *widget,gpointer   data)
{
    int RetCheck;
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
    {
        RetCheck = CM_Operations.SetLoopbackMode(CANMateDev);
        gtk_widget_set_sensitive(normal,0);
        if(CANMATE_ERROR_SUCCESS != RetCheck)
        {
            gtk_label_set_text(GTK_LABEL(popup_label), "Mode Selection Failed");
            gtk_widget_show(popup);
        }
    }
    else
    {
        gtk_widget_set_sensitive(normal,1);
    }
}
/*function set CANMATE to operate in normal mode*/
/*deactivate loopback mode selection if tick normal mode button*/
/*activate normal mode and loopback mode for selection if untick normal mode button*/
static void normal_mode (GtkWidget *widget,gpointer   data)
{
    int RetCheck;
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
    {
        RetCheck = CM_Operations.SetNormalMode(CANMateDev);
        gtk_widget_set_sensitive(loop,0);

        if(CANMATE_ERROR_SUCCESS != RetCheck)
        {
            gtk_label_set_text(GTK_LABEL(popup_label), "Mode Selection Failed");
            gtk_widget_show(popup);
        }
    }
    else
    {
        gtk_widget_set_sensitive(loop,1);
    }
}

/*function enables reception*/

static void reception (GtkWidget *widget,gpointer   data)
{
    int RetCheck;
    RetCheck = CM_Operations.StartReception(CANMateDev);
    if(CANMATE_ERROR_SUCCESS != RetCheck)
    {
        gtk_label_set_text(GTK_LABEL(popup_label), "Start Reception Failed");
        gtk_widget_show(popup);
    }
    else
    {
        BReadRX = TRUE;
        gtk_widget_set_sensitive(stoprecv,BReadRX);
        gtk_widget_set_sensitive(recv,!BReadRX);
    }
}

/*function stops reception*/
static void StopRecep (GtkWidget *widget, gpointer data)
{
    int RetCheck;
    RetCheck = CM_Operations.StopReception(CANMateDev);
    if(CANMATE_ERROR_SUCCESS != RetCheck)
    {
        gtk_label_set_text(GTK_LABEL(popup_label), "Stop Reception Failed");
        gtk_widget_show(popup);
    }
    else
    {
        BReadRX = TRUE;
        gtk_widget_set_sensitive(recv,BReadRX);
        gtk_widget_set_sensitive(stoprecv,!BReadRX);
    }
}

/*function sends data */
/*type Tx indicates it is a transmited data showing in liststore and log file*/
static void transmit (GtkWidget *widget, gpointer   data)
{
    TxCAN();
    Type = "Tx";
    show_loop();
}

/*function for opening canmate port*/
/*if it opened ,display a popup window to indicate it*/
/*if it could not open, display a popup window to indicate it*/
static void open_can (GtkButton *button, gpointer  user_data)
{
    if(InitStatus)
    {
        if(!BOpenPORT)
        {
            CANMateDev = CM_Operations.OpenCANMate(ProcessData, ProcessEvent);
            if(CANMateDev < 1)
            {
                gtk_label_set_text(GTK_LABEL(popup_label), "CANMate Detection Failed");
                gtk_widget_show(popup);
            }
            else
            {
                BOpenPORT = TRUE;
                gtk_widget_set_sensitive(closedev,BOpenPORT);
                gtk_widget_set_sensitive(send,BOpenPORT);
                gtk_widget_set_sensitive(recv,BOpenPORT);
            }
        }
        else
        {
            gtk_label_set_text(GTK_LABEL(popup_label), "Already Opened");
            gtk_widget_show(popup);
        }
    }
    else
    {
        gtk_label_set_text(GTK_LABEL(popup_label), "Failed to Load Library");
        gtk_widget_show(popup);
    }

}

/* function gets values of id from id entry */
/* it check entry data is a valid id, if not, display popup window to indicate it (valid id 0-1FFFFFFF) and clear the entry value */
/* identifies the entered id is extended or not */
/* entry id is converted from string to unsigned char and store in sendindg buffer id position */

static void Id (GtkEntry *entry, gpointer user_data)
{
    int ishexflag;
    int i,j=6;
    int length ;
    unsigned char HexId[3];
    const unsigned char *EntryId;

    plBuf[3]=0x00;
    plBuf[4]=0x00;
    plBuf[5]=0x00;
    plBuf[6]=0x00;

    EntryId = gtk_entry_get_text (entry);
    length = strlen(EntryId);
    for(i=0; i<length; i++)
    {
        if(((EntryId[i]<='9'&&EntryId[i]>='0')||(EntryId[i]<='f'&&EntryId[i]>='a')||(EntryId[i]<='F'&&EntryId[i]>='A'))&&(i!=7||EntryId[0]=='0'||EntryId[0]=='1'))
        {
            ishexflag=1;
            if(length>3 ||((length==3)&& (EntryId[length-3]>'7')))
            {
                plBuf[0] = 0x01;
            }
            else
            {
                plBuf[0] = 0x00;
            }
        }
        else
        {
            gtk_label_set_text(GTK_LABEL(popup_label), "Enter a valid Id");
            gtk_widget_show(popup);
            gtk_entry_set_text(entry, "");
            ishexflag=0;
        }
    }

    length--;
    while(length>=0 && ishexflag)
    {
        HexId[1]=EntryId[length--];

        if(length < 0)
        {
            HexId[0] = '0';
        }
        else
        {
            HexId[0]=EntryId[length--];
        }

        plBuf[j--] = strtol(HexId, NULL, 16);
    }
}

/* function gets values of Dlc from Dlc entry  it check entry data is a valid Dlc, if not,
display popup window to indicate it(valid dlc 0-8) and clear  the entry value entry Dlc is converted
from string to unsigned char and store in sendindg buffer Dlc position */

void Dlc (GtkEntry *entry, gpointer  user_data)
{
    const char *EntryDlc;
    unsigned char HexDlc ;
    EntryDlc = gtk_entry_get_text (entry);

    HexDlc = strtol(EntryDlc, NULL, 16);
    if((EntryDlc[0]>'8'||EntryDlc[0]<'0')&&EntryDlc[0]!=0)
    {
        gtk_label_set_text(GTK_LABEL(popup_label), "Invalid value for Dlc");
        gtk_widget_show(popup);
        gtk_entry_set_text(entry, "");
    }
    else
    {
        plBuf[7] = HexDlc;
    }
}


void help_about(GtkWidget *widget)
{
    gtk_dialog_run(GTK_DIALOG(widget));
}

/*function quit ui application on clicking quit */
/*it closes file descripter if ticked logw button before quit */
/*it closes canmate before quit */
void on_window_destroy (GtkWidget *object, gpointer user_data)
{
    if(csv != NULL)
    {
        fclose(csv);
    }
    CM_Operations.CloseCANMate(CANMateDev);
    gtk_main_quit();
}

/*function prints transmitted and received values in liststore and logfile*/
/*converts transmitted and recieved unsigned char values into string for print it in liststore */
/*write transmitted and received values in unsigned char format into logfile if logw button ticked */

void show_loop()
{
    int LoopCount ;
    char TimStampStr[10];
    float TimStampval;
    unsigned char RxIdPrint[8]= {0};
    unsigned char TxIdPrint[8]= {0};
    unsigned char printValueTxId[8]= {0};
    unsigned char PrintValueId[9]= {0};;
    unsigned char RxText[8]= {0};
    unsigned int Nibble1, Nibble2, Result;

    ItemNo++;
    if(Type == "Rx")
    {
        Nibble1 = LoopValue.chTmStmpH;
        Nibble2 = LoopValue.chTmStmpL;
        Result = (Nibble1 << 8) | Nibble2; // Bit Shifting

        TimStampval=(Result * 64.0)/1000.0;
        sprintf(TimStampStr, "%0.2f",TimStampval);

        if(LoopValue.bExtended)
        {
            sprintf(RxText,"%.2X%.2X%.2X%.2X",LoopValue.EArbId1,LoopValue.EArbId0,LoopValue.SArbId1,LoopValue.SArbId0);
        }
        else
        {
            sprintf(RxText,"%.2X%.2X",LoopValue.SArbId1,LoopValue.SArbId0);
        }

        for(LoopCount=0; LoopCount<8; LoopCount++)
        {
            if(RxText[LoopCount]!='0' && RxText[LoopCount]!=0)
            {
                strcpy(RxIdPrint,&RxText[LoopCount]);
                break;
            }
            if( RxIdPrint[0]==0)
            {
                RxIdPrint[0]='0';
            }
        }

        sprintf( PrintValueRx[1], "%X",LoopValue.DLC );
        sprintf( PrintValueRx[2], "%X",LoopValue.D0 );
        sprintf( PrintValueRx[3], "%X",LoopValue.D1 );
        sprintf( PrintValueRx[4], "%X",LoopValue.D2 );
        sprintf( PrintValueRx[5], "%X",LoopValue.D3 );
        sprintf( PrintValueRx[6], "%X",LoopValue.D4 );
        sprintf( PrintValueRx[7], "%X",LoopValue.D5 );
        sprintf( PrintValueRx[8], "%X",LoopValue.D6 );
        sprintf( PrintValueRx[9], "%X",LoopValue.D7 );

        gtk_list_store_prepend(store, &iter);
        gtk_list_store_set (store, &iter,0,ItemNo,1,TimStampStr,2,RxIdPrint,3, PrintValueRx[1], 4, PrintValueRx[2],5 , PrintValueRx[3],6,PrintValueRx[4],7,PrintValueRx[5],8,PrintValueRx[6],9,PrintValueRx[7],10,PrintValueRx[8],11,PrintValueRx[9],12,Type, -1 );
    }
    else
    {
        strcpy(TimStampStr,"0.00");
        sprintf(printValueTxId,"%X%.2X%.2X%.2X",plBuf[3],plBuf[4],plBuf[5],plBuf[6]);

        for(LoopCount=0; LoopCount<8; LoopCount++)
        {
            if(printValueTxId[LoopCount]!='0'&&printValueTxId[LoopCount]!=0)
            {
                strcpy(TxIdPrint,&printValueTxId[LoopCount]);
                break;
            }

            if( TxIdPrint[0]==0)
            {
                TxIdPrint[0]='0';

            }
        }

        for(LoopCount =0; LoopCount  < 10; LoopCount ++)
        {
            sprintf( PrintValueTx[LoopCount ], "%X",plBuf[LoopCount +6] );
        }

        gtk_list_store_prepend(store, &iter);

        gtk_list_store_set (store, &iter,0,ItemNo,1,TimStampStr,2, TxIdPrint,3, PrintValueTx[1], 4, PrintValueTx[2],5 ,PrintValueTx[3],6,PrintValueTx[4],7,PrintValueTx[5],8,PrintValueTx[6],9,PrintValueTx[7],10,PrintValueTx[8],11,PrintValueTx[9],12,Type, -1 );
    }

    if(csv!=NULL)
    {
        if(Type == "Rx")
        {
            fprintf(csv,"%d,%s,%s , %X , %X, %X, %X, %X, %X, %X, %X, %X,%s\n",ItemNo,TimStampStr,RxIdPrint,LoopValue.DLC,LoopValue.D0,LoopValue.D1,LoopValue.D2,LoopValue.D3,LoopValue.D4,LoopValue.D5,LoopValue.D6,LoopValue.D7,Type);
        }
        else
        {
            fprintf(csv,"%d,%s,%s , %X , %X, %X, %X, %X, %X, %X, %X, %X,%s\n",ItemNo,TimStampStr,TxIdPrint , plBuf[7], plBuf[8], plBuf[9], plBuf[10], plBuf[11],plBuf[12],plBuf[13],plBuf[14],plBuf[15],Type);
        }
    }
}

void show_about(GtkWidget *widget, gpointer user_data)
{
    gtk_dialog_run(GTK_DIALOG (Abt));
    gtk_widget_hide(Abt);
}

void close_about(GtkWidget *widget, gpointer user_data)
{
    gtk_widget_destroy(user_data);
}

/* function gets values from data entries(D0-D7) */
/* checks validity of each data , if not valid display popup to indicate and clear the entry */
/* each entry data is converted from string to unsigned char and stored in transmit buffer data position */

void static EntryVals(GtkEntry *entry, int* user_data)
{
    int Entrylength,i;
    const  char *EntryData;
    int index = *user_data;

    EntryData = gtk_entry_get_text (entry);
    Entrylength =  strlen(EntryData);

    for(i=0; i<Entrylength; i++)
    {
        if((EntryData[i]<='9'&&EntryData[i]>='0')||(EntryData[i]<='f'&&EntryData[i]>='a')||(EntryData[i]<='F'&&EntryData[i]>='A'))
        {
            plBuf[index] = strtol(EntryData, NULL, 16);/*convert string data to unsigned char*/
        }
        else
        {
            gtk_label_set_text(GTK_LABEL(popup_label), "Enter a hex value");
            gtk_widget_show(popup);
            gtk_entry_set_text(entry, "");
        }
    }
}

void popup_wid(GtkWidget *widget, gpointer data)
{
    gtk_widget_hide(data);
}

/* function setups liststore  and treeview */
static void setup_tree_view (GtkWidget *treeview)
{
    int ColumnNo ;
    char label[13][14] = {"#","TimeStamp(ms)","ID","DLC","D0","D1","D2","D3","D4","D5","D6","D7","Type"};
    GtkCellRenderer *renderer;
    GtkTreeViewColumn *column;
    for(ColumnNo=0; ColumnNo<13; ColumnNo++)
    {
        renderer = gtk_cell_renderer_text_new ();
        column = gtk_tree_view_column_new_with_attributes (label[ColumnNo], renderer, "text",ColumnNo, NULL);
        gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
    }
}

/******************************* MAIN *****************************************************/

int main (int argc, char *argv[])
{
    int TxBuffIndex[]= {6,8,9,10,11,12,13,14,15};
    GtkBuilder *builder;
    GtkWidget  *DLC,*ID;
    GtkWidget *menubar,*filemenu,*help,*quit,*scrolled_win,*treeview1;
    GtkWidget *check,*Abt_but;

    gtk_init (&argc, &argv);

    builder = gtk_builder_new ();
    gtk_builder_add_from_file (builder, "/usr/share/CANMate/ui.glade", NULL);

    window = GTK_WIDGET (gtk_builder_get_object (builder, "window1"));
    g_signal_connect (window, "destroy", G_CALLBACK (on_window_destroy), NULL);

    popup = GTK_WIDGET (gtk_builder_get_object (builder, "dialog1"));
    popup_label = GTK_WIDGET (gtk_builder_get_object (builder, "label34"));

    popup_but = GTK_WIDGET (gtk_builder_get_object (builder, "button8"));
    g_signal_connect (popup_but, "clicked", G_CALLBACK (popup_wid), popup);

    combo = GTK_WIDGET (gtk_builder_get_object (builder, "comboboxtext1"));
    g_signal_connect (combo, "changed", G_CALLBACK (combo_selected), NULL);

    quit=GTK_WIDGET (gtk_builder_get_object (builder, "imagemenuitem5"));
    g_signal_connect (quit, "button-press-event", G_CALLBACK (on_window_destroy), NULL);

    Abt = GTK_WIDGET (gtk_builder_get_object (builder, "aboutdialog1"));
    Abt_but = GTK_WIDGET (gtk_builder_get_object (builder, "aboutdialog-action_area1"));

    AbtClose= GTK_WIDGET (gtk_builder_get_object (builder, "aboutdialog-action_area1"));

    help = GTK_WIDGET (gtk_builder_get_object (builder, "imagemenuitem10"));
    g_signal_connect (help, "button-press-event", G_CALLBACK (show_about), Abt);

    opendev = GTK_WIDGET (gtk_builder_get_object (builder, "button4"));
    g_signal_connect (opendev, "clicked", G_CALLBACK (open_can), NULL);

    closedev = GTK_WIDGET (gtk_builder_get_object (builder, "button1"));
    g_signal_connect (closedev, "clicked", G_CALLBACK (close_can), NULL);

    logw = GTK_WIDGET (gtk_builder_get_object (builder, "checkbutton1"));
    gtk_widget_set_sensitive(logw,Recep);
    g_signal_connect (logw, "clicked", G_CALLBACK (log_file), NULL);

    loop = GTK_WIDGET (gtk_builder_get_object (builder, "checkbutton2"));
    gtk_widget_set_sensitive(loop,BaudSet);
    g_signal_connect (loop, "clicked", G_CALLBACK (loop_back), NULL);


    normal = GTK_WIDGET (gtk_builder_get_object (builder, "checkbutton3"));
    gtk_widget_set_sensitive(normal,BaudSet);
    g_signal_connect (normal, "clicked", G_CALLBACK (normal_mode), NULL);

    recv = GTK_WIDGET (gtk_builder_get_object (builder, "button6"));
    g_signal_connect (recv, "clicked", G_CALLBACK (reception), NULL);

    stoprecv = GTK_WIDGET (gtk_builder_get_object (builder, "button5"));
    g_signal_connect (stoprecv, "clicked", G_CALLBACK (StopRecep), NULL);

    send = GTK_WIDGET (gtk_builder_get_object (builder, "button2"));
    g_signal_connect (send, "clicked", G_CALLBACK (transmit), NULL);

    ID = GTK_WIDGET (gtk_builder_get_object (builder, "entry10"));
    g_signal_connect (ID, "changed", G_CALLBACK (Id),&TxBuffIndex[0]);

    DLC = GTK_WIDGET (gtk_builder_get_object (builder, "entry11"));
    g_signal_connect (DLC, "changed", G_CALLBACK (Dlc), NULL);

    D0En = GTK_WIDGET (gtk_builder_get_object (builder, "entry1"));
    g_signal_connect (D0En, "changed", G_CALLBACK (EntryVals),&TxBuffIndex[1]);

    D1En = GTK_WIDGET (gtk_builder_get_object (builder, "entry2"));
    g_signal_connect (D1En, "changed", G_CALLBACK (EntryVals),&TxBuffIndex[2]);

    D2En = GTK_WIDGET (gtk_builder_get_object (builder, "entry3"));
    g_signal_connect (D2En, "changed", G_CALLBACK (EntryVals), &TxBuffIndex[3]);

    D3En = GTK_WIDGET (gtk_builder_get_object (builder, "entry4"));
    g_signal_connect (D3En, "changed", G_CALLBACK (EntryVals), &TxBuffIndex[4]);

    D4En = GTK_WIDGET (gtk_builder_get_object (builder, "entry5"));
    g_signal_connect (D4En, "changed", G_CALLBACK (EntryVals), &TxBuffIndex[5]);

    D5En = GTK_WIDGET (gtk_builder_get_object (builder, "entry6"));
    g_signal_connect (D5En, "changed", G_CALLBACK (EntryVals),&TxBuffIndex[6]);

    D6En = GTK_WIDGET (gtk_builder_get_object (builder, "entry7"));
    g_signal_connect (D6En, "changed", G_CALLBACK (EntryVals),&TxBuffIndex[7]);

    D7En = GTK_WIDGET (gtk_builder_get_object (builder, "entry8"));
    g_signal_connect (D7En, "changed", G_CALLBACK (EntryVals), &TxBuffIndex[8]);

    ID_label = GTK_WIDGET (gtk_builder_get_object (builder, "label24"));
    DLC_label = GTK_WIDGET (gtk_builder_get_object (builder, "label25"));
    D0Lab = GTK_WIDGET (gtk_builder_get_object (builder, "label26"));
    D1Lab = GTK_WIDGET (gtk_builder_get_object (builder, "label27"));
    D2Lab = GTK_WIDGET (gtk_builder_get_object (builder, "label28"));
    D3Lab = GTK_WIDGET (gtk_builder_get_object (builder, "label29"));
    D4Lab = GTK_WIDGET (gtk_builder_get_object (builder, "label30"));
    D5Lab = GTK_WIDGET (gtk_builder_get_object (builder, "label31"));
    D6Lab = GTK_WIDGET (gtk_builder_get_object (builder, "label32"));
    D7Lab = GTK_WIDGET (gtk_builder_get_object (builder, "label33"));

    treeview1 = GTK_WIDGET (gtk_builder_get_object (builder, "treeview1"));
    store = gtk_list_store_new (13,G_TYPE_INT,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_STRING);

    setup_tree_view (treeview1);
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview1), GTK_TREE_MODEL (store));
    g_object_unref (store);

    gtk_widget_set_sensitive(closedev,BOpenPORT);
    gtk_widget_set_sensitive(send,BOpenPORT);
    gtk_widget_set_sensitive(recv,BOpenPORT);
    gtk_widget_set_sensitive(stoprecv,BReadRX);

    FindPath();
    InitStatus = InitLib();
    gtk_widget_show_all (window);
    gtk_main ();
    if(InitStatus)
        DeInitLib();
    return 0;
}
